unit crt82516;
interface
uses tmouse,crt;
type
scrptr=^scr;
scr=record
      symbol: array[1..80,1..25] of char;
      cs:     array[1..80,1..25] of byte;
      cbk:    array[1..80,1..25] of byte;
     end;
ndscreen=record
        symbol: array[1..80,1..25] of char;
        cs:     array[1..80,1..25] of byte;
        cbk:    array[1..80,1..25] of byte;
     end;
button=record
     x1,x2,y1,y2:byte;
     textb:string;
     color:byte;
     visible:boolean;
     end;
butto=^butt;
   butt=record
     x1,x2,y1,y2:byte;
     textb:string;
     color:byte;
     visible:boolean;
     end;
dialog=record
    x1,y1,x2,y2p:byte;
    bk:byte;
    mbsx,mbsy:byte;
    textk:string;
    end;
uef=record
    x1,y1,x2,y2p:byte;
    bk:byte;
    mbsx,mbsy:byte;
    textk:string;
    end;
sndptr=^snd;
snd=record
 dlay:integer;
 chist:integer;
 end;
ndsnd=record
 dlay:integer;
 chist:integer;
 afterdelay:integer;
 end;
message=record
    x1,y1,x2,y2p:byte;
    bk:byte;
    mbsx,mbsy:byte;
    textk:string;
    end;
const
    black=0;magenta=5;lightgreen=10;
    blue=1;brown=6;lightcyan=11;
    green=2;lightgray=7;lightred=12;
    cyan=3;darkgray=8;lightmagenta=13;
    red=4;lightblue=9;yellow=14;
    white=15;

procedure init802516;
procedure chxy(x,y:byte;c:char;scolor:byte;fcolor:byte);
function chin(x,y:byte):char;
function gchc(x,y:byte):byte;
function gchf(x,y:byte):byte;
procedure cls;
procedure tbgr(color:byte;c2:byte;symbol:char);
procedure textto(x,y:byte;s:string;bk:byte;c:byte);
procedure savescreen(var sc:scrptr);
procedure loadscreen(var sc:scrptr);
procedure saveobl(var sc:scrptr;x1,y1,x2,y2:byte);
procedure loadobl(var sc:scrptr;x1,y1,x2,y2:byte);
procedure savendobl(var sc:ndscreen;x1,y1,x2,y2:byte);
procedure loadndobl(var sc:ndscreen;x1,y1,x2,y2:byte);
procedure savescr(var sc:ndscreen);
procedure loadscr(var sc:ndscreen);
procedure oblgr(x1,y1,x2,y2:byte;color,c2:byte;symbol:char);
procedure box(x1,y1,x2,y2:byte;color:byte);
function in_1(x,y:byte;but:button):boolean;
function in_v(x,y:byte;but:butto):boolean;
procedure create_button(var but:button;x1,y1,x2,y2:byte;textb:string;color:byte);
procedure button_to(but:button);
procedure create_d(var but:butto;x1,y1,x2,y2:byte;textb:string;color:byte);
procedure button_d(but:butto);
procedure create_dialog(var dia:dialog;x1,y1,x2,y2p:byte;bk:byte;textk:string);
procedure draw_dialog(var dia:dialog);
procedure create_unf(var dia:uef;x1,y1,x2,y2p:byte;bk:byte;textk:string);
procedure draw_unf(var dia:uef);
procedure create_msg(var dia:message;x1,y1,x2,y2p:byte;bk:byte;textk:string);
procedure draw_msg(var dia:message);
procedure initsound(var sund:sndptr;dlay,chist:integer);
procedure playsound(sund:sndptr);
procedure initsnd(var sund:ndsnd;dlay,chist,dela:integer);
procedure playsnd(sund:ndsnd);
 implementation
procedure init802516;
begin
   asm
     mov ax,3
     int 10h
   end;
end;
procedure chxy(x,y:byte;c:char;scolor:byte;fcolor:byte);
begin
   mem[$B800:(((x-1)*2)+160*(y-1))]:=ord(c);
   mem[$B800:((((x-1)*2)+160*(y-1)))+1]:=fcolor*16+scolor;
end;
function chin(x,y:byte):char;
begin
   chin:=chr(mem[$B800:(((x-1)*2)+160*(y-1))]);
end;
function gchc(x,y:byte):byte;
begin
   gchc:=mem[$B800:((((x-1)*2)+160*(y-1))+1)] mod 16;
end;
function gchf(x,y:byte):byte;
begin
   gchf:=mem[$B800:((((x-1)*2)+160*(y-1))+1)] div 16;
end;
procedure cls;
var i,j:byte;
begin
   for i:=1 to 80 do
    for j:=1 to 25 do
     chxy(i,j,' ',0,0);
end;
procedure tbgr(color:byte;c2:byte;symbol:char);
var x,y:byte;
begin
   for x:=1 to 80 do
    for y:=1 to 25 do
     chxy(x,y,symbol,c2,color);
end;
procedure textto(x,y:byte;s:string;bk:byte;c:byte);
var i:integer;
begin
   for i:=0 to length(s)-1 do
   chxy(x+i,y,s[i+1],c,bk);
end;
procedure savescreen(var sc:scrptr);
var x,y:byte;
begin
   new(sc);
    for x:=1 to 80 do
     for y:=1 to 25 do
     begin
        sc^.symbol[x,y]:=chin(x,y);
        sc^.cs[x,y]:=gchc(x,y);
        sc^.cbk[x,y]:=gchf(x,y);
     end;
end;
procedure loadscreen(var sc:scrptr);
var x,y:byte;
begin
   for x:=1 to 80 do
    for y:=1 to 25 do
    begin
        chxy(x,y,sc^.symbol[x,y],sc^.cs[x,y],sc^.cbk[x,y]);
    end;
    DISPOSE(sc);
end;
procedure saveobl(var sc:scrptr;x1,y1,x2,y2:byte);
var x,y:byte;
begin
   new(sc);
    for x:=x1 to x2 do
     for y:=y1 to y2 do
     begin
        sc^.symbol[x,y]:=chin(x,y);
        sc^.cs[x,y]:=gchc(x,y);
        sc^.cbk[x,y]:=gchf(x,y);
     end;
end;
procedure loadobl(var sc:scrptr;x1,y1,x2,y2:byte);
var x,y:byte;
begin
   for x:=x1 to x2 do
    for y:=y1 to y2 do
    begin
        chxy(x,y,sc^.symbol[x,y],sc^.cs[x,y],sc^.cbk[x,y]);
    end;
    DISPOSE(sc);
end;
procedure savendobl(var sc:ndscreen;x1,y1,x2,y2:byte);
var x,y:byte;
begin
    for x:=x1 to x2 do
     for y:=y1 to y2 do
     begin
        sc.symbol[x,y]:=chin(x,y);
        sc.cs[x,y]:=gchc(x,y);
        sc.cbk[x,y]:=gchf(x,y);
     end;
end;
procedure loadndobl(var sc:ndscreen;x1,y1,x2,y2:byte);
var x,y:byte;
begin
   for x:=x1 to x2 do
    for y:=y1 to y2 do
    begin
        chxy(x,y,sc.symbol[x,y],sc.cs[x,y],sc.cbk[x,y]);
    end;
end;
procedure savescr(var sc:ndscreen);
var x,y:byte;
begin
    for x:=1 to 80 do
     for y:=1 to 25 do
     begin
        sc.symbol[x,y]:=chin(x,y);
        sc.cs[x,y]:=gchc(x,y);
        sc.cbk[x,y]:=gchf(x,y);
     end;
end;
procedure loadscr(var sc:ndscreen);
var x,y:byte;
begin
   for x:=1 to 80 do
    for y:=1 to 25 do
    begin
        chxy(x,y,sc.symbol[x,y],sc.cs[x,y],sc.cbk[x,y]);
    end;
end;
procedure oblgr(x1,y1,x2,y2:byte;color,c2:byte;symbol:char);
var x,y:byte;
begin
   for x:=x1 to x2 do
    for y:=y1 to y2 do
     chxy(x,y,symbol,c2,color);
end;
procedure box(x1,y1,x2,y2:byte;color:byte);
var i,j:byte;
begin
      for i:=x1+1 to x2-1 do
       begin
      chxy(i,y1,#205,color,blue);
      chxy(i,y2,#205,color,blue);
       end;
      for j:=y1+1 to y2-1 do
       begin
       chxy(x1,j,#186,color,blue);
       chxy(x2,j,#186,color,blue);
      end;
       chxy(x1,y1,#201,color,blue);
       chxy(x1,y2,#200,color,blue);
       chxy(x2,y1,#187,color,blue);
       chxy(x2,y2,#188,color,blue);
end;
function in_1(x,y:byte;but:button):boolean;
begin
  if (x>=but.x1) and (x<=but.x2) and (y>=but.y1) and (y<=but.y2) then
  in_1:=true
    else
     in_1:=false;
end;
function in_v(x,y:byte;but:butto):boolean;
begin
  if (x>=but^.x1) and (x<=but^.x2) and (y>=but^.y1) and (y<=but^.y2) then
  in_v:=true
    else
     in_v:=false;
end;
procedure create_button(var but:button;x1,y1,x2,y2:byte;textb:string;color:byte);
begin
   but.x1:=x1;but.x2:=x2;
   but.y1:=y1;but.y2:=y2;
   but.textb:=textb;
end;
procedure button_to(but:button);
begin
  box(but.x1,but.y1,but.x2,but.y2,but.color);
  textto((but.x1+(but.x2-but.x1) div 2)-length(but.textb) div 2,but.y1+1,but.textb,blue,red);
end;
procedure create_d(var but:butto;x1,y1,x2,y2:byte;textb:string;color:byte);
begin
   but^.x1:=x1;but^.x2:=x2;
   but^.y1:=y1;but^.y2:=y2;
   but^.textb:=textb;
end;
procedure button_d(but:butto);
begin
  box(but^.x1,but^.y1,but^.x2,but^.y2,but^.color);
  textto((but^.x1+(but^.x2-but^.x1) div 2)-length(but^.textb) div 2,but^.y1+1,but^.textb,blue,red);
end;
procedure create_dialog(var dia:dialog;x1,y1,x2,y2p:byte;bk:byte;textk:string);
begin
   dia.x1:=x1;
   dia.y1:=y1;
    dia.x2:=x2;
   dia.y2p:=y2p;
   dia.bk:=bk;dia.mbsx:=dia.x1+3;
   dia.mbsy:=dia.y1;dia.textk:=textk;
end;
procedure draw_dialog(var dia:dialog);
var ns:ndscreen;
    x,y,key:integer;
    i,j:byte;
begin
   savescr(ns);
   for i:=dia.x1 to dia.x2 do
    for j:=dia.y1 to dia.y2p do
    begin
     chxy(i,j,' ',blue,blue);
    end;
    box(dia.x1,dia.y1,dia.x2,dia.y2p,white);
   textto(dia.x1+2,dia.y1,'[',blue,white);
   textto(dia.x1+4,dia.y1,']',blue,white);
   textto(dia.x1+3,dia.y1,#9,blue,green);
   textto(dia.x1+1,((dia.y2p-dia.y1) div 2)+dia.y1,dia.textk,blue,white);
    repeat
     readms(key,x,y);
     x:=x div 8;
     y:=y div 8;
    until ((key=1) and ((x=dia.mbsx-1) and (y=dia.mbsy-1)));
   loadscr(ns);
end;
procedure create_unf(var dia:uef;x1,y1,x2,y2p:byte;bk:byte;textk:string);
begin
   dia.x1:=x1;
   dia.y1:=y1;
    dia.x2:=x2;
   dia.y2p:=y2p;
   dia.bk:=bk;dia.mbsx:=dia.x1+3;
   dia.mbsy:=dia.y1;dia.textk:=textk;
end;
procedure draw_unf(var dia:uef);
var ns:ndscreen;
    x,y,key:integer;
    i,j:byte;
    ch:char;
begin
   savescr(ns);
   for i:=dia.x1 to dia.x2 do
    for j:=dia.y1 to dia.y2p do
    begin
     chxy(i,j,' ',blue,blue);
    end;
    box(dia.x1,dia.y1,dia.x2,dia.y2p,blue);
   textto(dia.x1+2,dia.y1,'[',blue,white);
   textto(dia.x1+4,dia.y1,']',blue,white);
   textto(dia.x1+3,dia.y1,#9,blue,green);
   textto(dia.x1+1,((dia.y2p-dia.y1) div 2)+dia.y1,dia.textk,blue,white);
   window(dia.x1+1,dia.y1+1,dia.x2-1,dia.y2p-1);textbackground(blue);clrscr;
    repeat
     readms(key,x,y);
     x:=x div 8;
     y:=y div 8;
     if ((key=1) and ((x<>dia.mbsx-1) and (y<>dia.mbsy-1))) then
     gotoxy(x,y);
     read;
    until ((key=1) and ((x=dia.mbsx-1) and (y=dia.mbsy-1)));
   loadscr(ns);
end;
procedure create_msg(var dia:message;x1,y1,x2,y2p:byte;bk:byte;textk:string);
begin
   dia.x1:=x1;
   dia.y1:=y1;
    dia.x2:=x2;
   dia.y2p:=y2p;
   dia.bk:=bk;dia.mbsx:=dia.x1+3;
   dia.mbsy:=dia.y1;dia.textk:=textk;
end;
procedure draw_msg(var dia:message);
var ns:ndscreen;
    x,y,key:integer;
    i,j:byte;
begin
   savescr(ns);
   for i:=dia.x1 to dia.x2 do
    for j:=dia.y1 to dia.y2p do
    begin
     chxy(i,j,' ',blue,blue);
    end;
    box(dia.x1,dia.y1,dia.x2,dia.y2p,white);
   textto(dia.x1+2,dia.y1,'[',blue,white);
   textto(dia.x1+4,dia.y1,']',blue,white);
   textto(dia.x1+3,dia.y1,#9,blue,green);
   textto((dia.x1+(dia.x2) div 2)-length(dia.textk),((dia.y2p-dia.y1) div 2)+dia.y1,dia.textk,blue,white);
    repeat
     readms(key,x,y);
     x:=x div 8;
     y:=y div 8;
    until ((key=1) and ((x=dia.mbsx-1) and (y=dia.mbsy-1)));
   loadscr(ns);
end;
procedure initsound(var sund:sndptr;dlay,chist:integer);
begin
 sund^.dlay:=dlay;
 sund^.chist:=chist;
end;
procedure playsound(sund:sndptr);
begin
   sound(sund^.chist);
   delay(sund^.dlay);
   nosound;
end;
procedure initsnd(var sund:ndsnd;dlay,chist,dela:integer);
begin
 sund.dlay:=dlay;
 sund.chist:=chist;
 sund.afterdelay:=dela;
end;
procedure playsnd(sund:ndsnd);
begin
   sound(sund.chist);
   delay(sund.dlay);
   nosound;
   delay(sund.afterdelay);
end;
end.